=== debian/changelog ===
libvpl (1:2.15.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.15.0
  * d/p: Adding patches to ensure example installed. 
    - 0001-Revert-Stop-requiring-INSTALL_DEV-to-build-examples.patch

 -- Mustaffa, Mustamin B <mustamin.b.mustaffa@intel.com>  Sat, 23 Aug 2025 01:28:57 +0800

libvpl (1:2.14.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.14.0

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 27 Mar 2025 18:28:25 +0800

libvpl (1:2.13.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.13.0
  * d/p: remove a patches already merged.
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 07 Jan 2025 15:58:18 +0800

libvpl (1:2.12.0-1ppa1~noble1) noble; urgency=medium

  * Bump to 2.12.0
  * d/p: remove list of patches already merged and due to split repository for
    samples app.
    - 0001-Add-in-VVC-decode-feature.patch
    - 0001-Added-cmake-install-for-metrics-monitor-tools.patch
    - 0001-Allow-SMT-exit-with-no-encode-codec-is-set.patch
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0001-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0001-Fix-green-output-on-Y416-format.patch
    - 0001-Revert-YUV400-JPEG-Enc-for-d3d9-and-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0002-Fix-code-formatting.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-d3d9.patch
    - 0003-Fix-rDRM-DMA-methods.patch
    - 0004-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0010-Fix-X11-render.patch
    - 0011-Fix-Wayland-render.patch
  * d/p: update libvpl2.install & libvpl-dev.install

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Mon, 09 Sep 2024 09:17:52 +0800

libvpl (1:2.10.2-1ppa1~noble7) noble; urgency=medium

  * debian/patches: Align patch with upstream
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0002-Fix-code-formatting.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Tue, 13 Aug 2024 10:45:03 +0800

libvpl (1:2.10.2-1ppa1~noble6) noble; urgency=medium

  * debian/patches: Fix X11 rendering for xe
    - 0001-Fix-X11-rendering-for-xe.patch
    - 0002-Fix-code-formatting.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Fri, 26 Jul 2024 23:39:50 +0800

libvpl (1:2.10.2-1ppa1~noble5) noble; urgency=medium

  * Add VVC decode feature for sample_decode.
    - 0001-Add-in-VVC-decode-feature.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 25 Jul 2024 13:10:37 +0800

libvpl (1:2.10.2-1ppa1~noble4) noble; urgency=medium

  * Add -DBUILD_EXAMPLES=ON compile option and YUV400/BGR4 (Updated version)
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 19 Jul 2024 14:37:57 +0800

libvpl (1:2.10.2-1ppa1~noble3) noble; urgency=medium

  * Correct YUV400/BGR4 (api1x/api2x) and aligned XE DMA rDRM
    - 0001-Revert-YUV400-JPEG-Enc-for-d3d9-and-d3d11.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0003-Fix-rDRM-DMA-methods.patch
    - 0004-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0001-Add-hello-encode-jpeg-api2x-example.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Tue, 4 Jul 2024 10:13:52 +0800

libvpl (1:2.10.2-1ppa1~noble2) noble; urgency=medium

  * Correct va-attrib and enable VPL YUV400 JPEG Enc
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0001-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-d3d11.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-d3d9.patch

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Mon, 20 May 2024 10:50:45 +0800

libvpl (1:2.10.2-1ppa1~noble1) noble; urgency=medium

  * bump to 2.10.2
  * Fix green output on sample decode for Y416
    - 0001-Fix-green-output-for-Y416-format.patch
  * Allow SMT to exit with no encode codec is set
    - 0001-Allow-SMT-exit-with-no-encode-codec-is-set.patch

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 08 May 2024 16:06:36 +0800

onevpl (2023.4.0-1ppa1~noble1) noble; urgency=medium

  * build for ubuntu 24.04.

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Wed, 17 Apr 2024 14:42:13 +0800

onevpl (2023.4.0-1ppa1~jammy3) jammy; urgency=medium

  * missing dependency install step added

 -- Rameshkrishnan, Geddy Sekar <rameshkrishnan.geddy.sekar@intel.com>  Tue, 27 Feb 2024 23:44:21 +0530

onevpl (2023.4.0-1ppa1~jammy2) jammy; urgency=medium

  * Added cmake installing cttmetrics library and metrics monitor
    tools.
    - 0001-Added-cmake-install-for-metrics-monitor-tools.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 27 Feb 2024 12:44:14 +0800

onevpl (2023.4.0-1ppa1~jammy1) jammy; urgency=medium

  * Upstream release 2023.4.0
  * debian/patches: drop patches already merged
    - 0001-Fix-rdrm-NV12-and-P010-render-for-MTL.patch
    - 0002-Encode-more-frame-than-shortest-video-frames.patch
    - 0003-Fix-NV12-wayland-render-for-MTL.patch
    - 0004-Fix-dGfx-option-for-Linux.patch
    - 0005-Fix-rdrm-to-use-card-node-instead-of-render-node.patch
    - 0006-Fix-rdrm-tile4-selection-based-DRM-KMS-query.patch
    - 0007-Remove-unused-codes.patch
    - 0008-Enable-JPEG-BGR4-encode.patch
    - 0009-Fix-sample_decode-output-format-print.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 31 Jan 2024 10:48:33 +0800

onevpl (2023.3.1-1ppa1~jammy3) jammy; urgency=medium

  * debian/patches: Fix X11 & Wayland rendering for hybrid mode
    - 0009-Fix-sample_decode-output-format-print.patch
    - 0010-Fix-X11-render.patch
    - 0011-Fix-Wayland-render.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Thu, 04 Jan 2024 09:16:36 +0800

onevpl (2023.3.1-1ppa1~jammy2) jammy; urgency=medium

  *   Enable JPEG BGR4 encode

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 17 Nov 2023 20:49:17 +0800

onevpl (2023.3.1-1ppa1~jammy1) jammy; urgency=medium

  * Upstream release 2023.3.1
  * debian/patches: rebase the list of patches.


