=== debian/control ===
Source: libvpl
Section: libs
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libwayland-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb1-dev,
 libxcb-dri3-dev,
 libxcb-present-dev,
 pkg-config,
 wayland-protocols,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl
Vcs-Browser: https://salsa.debian.org/debian/libvpl
Vcs-Git: https://salsa.debian.org/debian/libvpl.git
Rules-Requires-Root: no

Package: libvpl2
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- shared library
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the dispatcher library

Package: libvpl-dev
Architecture: amd64 x32
Depends:
 libvpl2 (= ${binary:Version}),
 ${misc:Depends},
Description: oneAPI Video Processing Library -- development files
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes header files and examples for development.

Package: onevpl-tools
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- command line tools
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the command line tools.
