=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DVPL_INSTALL_ENVDIR=/usr/share/vpl/env \
		-DBUILD_EXAMPLES=ON \
		-DINSTALL_EXAMPLES=ON

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/share/doc/oneVPL/license.txt \
		debian/tmp/usr/share/doc/oneVPL/third-party-programs.txt \
		debian/tmp/usr/share/oneVPL/examples
